#
# Conditional build:
%bcond_with	tests		# build with tests

%define		php_min_version 5.3.4
%include	/usr/lib/rpm/macros.php
Summary:	Dependency Manager for PHP
Name:		composer
Version:	1.6.2
Release:	1
License:	MIT
Group:		Development/Languages/PHP
Source0:	https://github.com/composer/composer/archive/%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	4a403a18c071b92db0f27bea337a669e
Source2:	https://raw.githubusercontent.com/iArren/%{name}-bash-completion/86a8129/composer
# Source2-md5:	cdeebf0a0da1fd07d0fd886d0461642e
Source3:	autoload.php
Patch0:		autoload.patch
Patch1:		update-memory-limit.patch
Patch2:		svn-ignore-externals.patch
URL:		https://getcomposer.org/
BuildRequires:	php-devel
BuildRequires:	rpm-php-pearprov >= 4.4.2-11
BuildRequires:	rpmbuild(macros) >= 1.673
%if %{with tests}
# instead of filling duplicate deps for running tests,
# update composer version that have neccessary runtime dependencies
BuildRequires:	composer >= 1.4.0
BuildRequires:	git-core
BuildRequires:	phpab
BuildRequires:	phpunit >= 4.8
%endif
Requires:	php(core) >= %{php_min_version}
Requires:	php(ctype)
Requires:	php(date)
Requires:	php(filter)
Requires:	php(hash)
Requires:	php(json)
Requires:	php(openssl)
Requires:	php(pcntl)
Requires:	php(pcre)
Requires:	php(phar)
Requires:	php(posix)
Requires:	php(simplexml)
Requires:	php(spl)
Requires:	php(zip)
Requires:	php(zlib)
Requires:	php-composer-ca-bundle >= 1.0.2
Requires:	php-composer-semver >= 1.0.0
Requires:	php-composer-spdx-licenses >= 1.2
Requires:	php-justinrainbow-json-schema >= 3.0
Requires:	php-psr-Log >= 1.0
Requires:	php-seld-cli-prompt >= 1.0.0
Requires:	php-seld-jsonlint >= 1.4
Requires:	php-seld-phar-utils >= 1.0.0
Requires:	php-symfony2-ClassLoader >= 2.7.7
Requires:	php-symfony2-Console >= 2.7.7
Requires:	php-symfony2-Finder >= 2.7.7
Requires:	php-symfony2-Process >= 2.7.7
Suggests:	bash-completion-%{name}
Suggests:	git-core
Suggests:	mercurial
Suggests:	subversion
Conflicts:	satis < 1.0.0-1.alpha1.193
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Composer is a tool for dependency management in PHP.

Composer helps you declare, manage and install dependencies of PHP
projects, ensuring you have the right stack everywhere.

%package -n bash-completion-%{name}
Summary:	Bash completion for Composer
Summary(pl.UTF-8):	bashowe uzupełnianie nazw dla Composera
Group:		Applications/Shells
Requires:	%{name}
Requires:	bash-completion >= 2.0

%description -n bash-completion-%{name}
Bash completion for Composer package and dependency manager.

%description -n bash-completion-%{name} -l pl.UTF-8
Pakiet ten dostarcza bashowe uzupełnianie nazw dla Composera.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1

mv composer.lock{,.disabled}
# NOTE: do not use %{__php} macro here, need unversioned php binary
%{__sed} -i -e '1s,^#!.*env php,#!/usr/bin/php,' bin/*

cp -p %{SOURCE3} src/Composer/autoload.php

# AutoloadGenerator needs this runtime
mv LICENSE res

# move to Composer dir, this will simplify testing
mv res src/Composer
ln -s src/Composer/res

# cleanup backups after patching
find '(' -name '*~' -o -name '*.orig' ')' -print0 | xargs -0 -r -l512 rm -f

%build
%if %{with tests}
phpab -n -o src/bootstrap.php -e '*/Fixtures/*' src/ tests/
echo "require 'src/Composer/autoload.php';" >> src/bootstrap.php
phpunit
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{php_data_dir}/Composer,/var/cache/composer}
cp -a src/Composer $RPM_BUILD_ROOT%{php_data_dir}
install -p bin/composer $RPM_BUILD_ROOT%{_bindir}/%{name}

install -d $RPM_BUILD_ROOT%{bash_compdir}
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{bash_compdir}/composer

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc README.md CHANGELOG.md PORTING_INFO
%doc src/Composer/res/LICENSE
%attr(755,root,root) %{_bindir}/composer
%{php_data_dir}/Composer

# top level cachedir, create user cache dirs here manually
%dir %attr(711,root,http) /var/cache/composer

%files -n bash-completion-%{name}
%defattr(644,root,root,755)
%{bash_compdir}/composer
%changelog
* Thu Jan 11 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/composer.git;a=log;h=master

* Thu Jan 11 2018 Elan Ruusamäe <glen@pld-linux.org> 73e8a31
- up to 1.6.2, 2018-01-05

* Tue Jan 02 2018 Elan Ruusamäe <glen@pld-linux.org> 8e63e7b
- 1.5.6 - 2017-12-18

* Wed Dec 13 2017 Elan Ruusamäe <glen@pld-linux.org> 419b876
- up to 1.5.5 (2017-12-01)

* Wed Dec 13 2017 Elan Ruusamäe <glen@pld-linux.org> 7d0581e
- up to 1.5.4 (2017-12-01)

* Wed Dec 13 2017 Elan Ruusamäe <glen@pld-linux.org> 74f3fdf
- up to 1.5.3 (2017-11-30)

* Tue Oct 24 2017 Elan Ruusamäe <glen@pld-linux.org> ba7fb69
- up to 1.5.2 (2017-09-11)

* Mon Sep 04 2017 Elan Ruusamäe <glen@pld-linux.org> 508b29d
- 1.5.1 - 2017-08-09

* Mon Sep 04 2017 Elan Ruusamäe <glen@pld-linux.org> e545fb2
- 1.5.0 - 2017-08-08

* Mon Sep 04 2017 Elan Ruusamäe <glen@pld-linux.org> 9850d64
- 1.4.3 - 2017-08-06

* Mon Jul 17 2017 Elan Ruusamäe <glen@pld-linux.org> e0160b7
- disable tests; requires newer phpunit than present in th

* Mon Jul 17 2017 Jan Rękorajski <baggins@pld-linux.org> 1dca7b6
- rel 1.1, build is broken

* Wed May 17 2017 Elan Ruusamäe <glen@delfi.ee> bab99b4
- 1.4.2 - 2017-05-17

* Mon May 15 2017 Elan Ruusamäe <glen@delfi.ee> 03fb109
- refs 154bbfb

* Tue Mar 28 2017 Elan Ruusamäe <glen@delfi.ee> ffa3a09
- bump test deps

* Tue Mar 28 2017 Elan Ruusamäe <glen@delfi.ee> 9b1d15a
- up to 1.4.1

* Sat Dec 24 2016 Elan Ruusamäe <glen@delfi.ee> c80c5b9
- 1.3.0 - 2016-12-24

* Fri Nov 18 2016 Elan Ruusamäe <glen@delfi.ee> 3981fe3
- fix tests for old phpunit

* Fri Nov 18 2016 Elan Ruusamäe <glen@delfi.ee> da3759c
- up to 1.2.2 - 2016-11-03

* Thu Sep 22 2016 Elan Ruusamäe <glen@delfi.ee> b79decc
- v1.2.1 - 2016-09-12

* Wed Aug 03 2016 Elan Ruusamäe <glen@delfi.ee> 8bf9faf
- up to 1.2.0; Security: Fixed httpoxy vulnerability

